---
include:
  - local: .gitlab/ci/nexus/nexus.yml

variables:
  HOPPR_NEXUS_BUNDLER_REF: main
  PIP_CACHE_DIR: $CI_PROJECT_DIR/.cache

.nexus-bundler:
  extends: .nexus
  cache:
    key: nexus-bundler-test-$CI_COMMIT_SHORT_SHA
    paths:
      - .cache
      - dist
      - nexus_bundler_test
  artifacts:
    when: always
    paths:
      - hoppr.log
  rules:
    - if: $CI_PIPELINE_SOURCE == "parent_pipeline"

download-test-data:nexus-bundler:
  extends: .nexus-bundler
  needs:
    - pipeline: $PARENT_PIPELINE_ID
      job: build-image:release
    - project: hoppr/plugins/hoppr-nexus-bundler
      ref: $HOPPR_NEXUS_BUNDLER_REF
      job: build-dist
  script:
    # Install nexus bundler plugin wheel to generate pip cache
    - docker compose exec hopctl python -m pip install dist/hoppr_nexus_bundler-*.whl

    # Download nexus bundler plugin repository source tar and extract integration testing data
    - mkdir nexus_bundler_test
    - download_url="${CI_API_V4_URL}/projects/hoppr%2Fplugins%2Fhoppr-nexus-bundler/repository/archive?sha=${HOPPR_NEXUS_BUNDLER_REF}&path=test/integration"
    - curl --fail --silent --show-error --location --url "$download_url" |
      tar --extract --gzip --strip-components=3 --directory=nexus_bundler_test
  cache:
    policy: push

.integration-test:nexus-bundler:
  extends: .nexus-bundler
  variables:
    # References path internal to `hopctl` service container
    TEST_DIR: ${CI_PROJECT_DIR}/nexus_bundler_test/${TEST_ID}
  needs:
    - job: download-test-data:nexus-bundler
  script:
    - printf "%s\n"
      "================================"
      "TEST_ID        ${TEST_ID}"
      "DESCRIPTION    ${TEST_ID} SBOM"
      "================================"

    # Install nexus bundler plugin from pip cache
    - docker compose exec hopctl python -m pip install dist/hoppr_nexus_bundler-*.whl

    - docker compose exec hopctl
      hopctl bundle --transfer "${TEST_DIR}/transfer.yml" --log hoppr.log --verbose "${TEST_DIR}/manifest.yml"
  artifacts:
    when: always
    expire_in: 1h
    paths:
      - hoppr.log
      - nexus-data
  cache:
    policy: pull

integration-test:nexus-bundler:docker:
  extends: .integration-test:nexus-bundler
  variables:
    TEST_ID: IntTest_2
  artifacts:
    when: always
    paths:
      - hoppr.log

integration-test:nexus-bundler:maven:
  extends: .integration-test:nexus-bundler
  variables:
    TEST_ID: IntTest_3

integration-test:nexus-bundler:python:
  extends: .integration-test:nexus-bundler
  variables:
    TEST_ID: IntTest_4

integration-test:nexus-bundler:combined:
  extends: .integration-test:nexus-bundler
  variables:
    TEST_ID: IntTest_5
